#include <afxwin.h>
#include <afxdlgs.h>
#include "resource.h"

/********** function pointers to call functions of myfunction.dll **********/
typedef BOOL (_cdecl* t_ps)();
typedef int (_cdecl* t_sar)(char*);
void WhatError();
/************** GLOBAL VARIABLES **************/
HINSTANCE hdll; t_ps putsignature; t_sar straltrev;
/***********************************************************/
class regdlg : public CDialog
{
private:
	HKEY rootkey, phkresult, tempkey;
	DWORD dwdisposition, dwvaluedata; 
	BYTE *binvaluedata;
	CString key, valuename, keyopen, strvaluedata; 
	int valuetype;
	char strval[1000];

public:
	regdlg(int r) : CDialog(r)
	{
	}

	void exitbtn()
	{
		RegCloseKey(phkresult); RegCloseKey(tempkey); 
		exit(0);
	}

	void closekey()
	{
		RegCloseKey(phkresult);RegCloseKey(tempkey);
	}

	void emptystrings()
	{
		key.Empty(); valuename.Empty(); keyopen.Empty(); strvaluedata.Empty();
	}

	void openkey()
	{
		GetDlgItemText(IDC_EDITOPENKEY,keyopen);
		if(keyopen=="")return;
		if( (RegOpenKeyEx(rootkey,keyopen,0,(ULONG)0,&phkresult)) != ERROR_SUCCESS)
			{
				WhatError();
				return;
			}
	}

	void addregkey()
	{
		openkey();
		if(keyopen==""){MessageBox("Enter any reg key in the text box.","Error"); return;}
		GetDlgItemText(IDC_EDITKEY,key);
		if(( RegCreateKeyEx(phkresult,key,0,0,0,(ULONG)0,0,&tempkey,&dwdisposition) )!= ERROR_SUCCESS)
		{
			MessageBox("Failed to create key","ERROR",MB_OK); return;
		}
		MessageBox("Key created successfully","Done");
		regflush(); closekey(); emptystrings();
	}

	void delregkey()
	{	
		openkey();
		GetDlgItemText(IDC_EDITKEY,key);
		if( (RegDeleteKey(phkresult,key)) != ERROR_SUCCESS)
			{
				MessageBox("Either key doesn't exists OR it contains subkeys","Error");
				return;
			}
			MessageBox("Key Deleted successfully","Done.");
		regflush(); closekey(); emptystrings();
	}

	void delregval()
	{
		openkey();
		GetDlgItemText(IDC_EDITVALUENAME,valuename);
		if( (RegDeleteValue(phkresult,valuename)) != ERROR_SUCCESS)
			{
				MessageBox("Entered value doesn't exist","Error");
				return;
			}
			MessageBox("Reg value Deleted successfully","Done.");
		regflush(); closekey(); emptystrings();
	}

	void setregval()
	{
		openkey();
		GetDlgItemText(IDC_EDITVALUENAME,valuename);
		GetDlgItemText(IDC_EDITVALUEDATA,strvaluedata);
		if(valuename==""){MessageBox("Enter any reg value.","Error"); return;}
		switch(valuetype)
		{
/* To set string value */
		case 0x2: case 0x1: case 0x7:
			GetDlgItemText(IDC_EDITVALUEDATA,strvaluedata);
			if(( RegSetValueEx(phkresult,(LPCTSTR)valuename,0,valuetype,(CONST BYTE*)(LPCSTR)strvaluedata,(DWORD)strvaluedata.GetLength()) )!= ERROR_SUCCESS)
				{
					MessageBox("Failed to set the entered regvalue","Error");
					return;
				}
			MessageBox("Reg value Set successfully","Done.");break;
/* To set dword value */
		case 0x4:
			GetDlgItemText(IDC_EDITVALUEDATA,strvaluedata); 
			sscanf(strvaluedata,"%x",&dwvaluedata);
			if(( RegSetValueEx(phkresult,(LPCTSTR)valuename,0,valuetype,(LPBYTE)&dwvaluedata,(DWORD)sizeof(dwvaluedata) ) )!= ERROR_SUCCESS)
				{
					MessageBox("Failed to set the entered regvalue","Error");
					return;
				}
			MessageBox("Reg value Set successfully","Done.");break;
/* To set Binary value */			
		case 0x3: 
				GetDlgItemText(IDC_EDITVALUEDATA,strvaluedata);
				strvaluedata.MakeReverse();
				strcpy(strval,strvaluedata); 
				if(straltrev)(*straltrev)(strval);
				sscanf(strval,"%x",&dwvaluedata);
				if(( RegSetValueEx(phkresult,(LPCTSTR)valuename,0,valuetype,(LPBYTE)&dwvaluedata,(DWORD)sizeof(dwvaluedata) ) )!= ERROR_SUCCESS)
				{
					MessageBox("Failed to set the entered regvalue","Error");
					return;
				}
				MessageBox("Reg value Set successfully","Done.");break;
		}
		regflush(); closekey(); emptystrings();
	}

	void regflush()
	{
		RegFlushKey(phkresult);
		closekey();emptystrings();
	}

	void radiohklm()
	{
		rootkey = ((HKEY)0x80000002);
	}

	void radiohkcu()
	{
		rootkey = ((HKEY)0x80000001); 
	}

	void radiohkcr()
	{
		rootkey = ((HKEY)0x80000000); 
	}

	void radiovaluestr()
	{
		valuetype = 0x1;
	}

	void radiovaluebinary()
	{
		valuetype = 0x3;
	}
	void radiovaluedword()
	{
		valuetype = 0x4;
	}

	void radiovaluemultistr()
	{
		valuetype = 0x7;
	}

	void radiovalueexpandstr()
	{
		valuetype = 0x2;
	}

	void clear()
	{
		SetDlgItemText(IDC_EDITKEY,"");SetDlgItemText(IDC_EDITOPENKEY,"");
		SetDlgItemText(IDC_EDITVALUE,"");SetDlgItemText(IDC_EDITVALUEDATA,"");SetDlgItemText(IDC_EDITVALUENAME,"");
		emptystrings();
	}

	void about()
	{
		MessageBox("Developed at Homelabs by Bindesh Kumar Singh.\nVisit: www.bindesh.cjb.net\nMail: bindesh_softwaretalk@yahoo.co.in","Dialog based registry editor.",MB_OK);
	}

/***************************************************/
	DECLARE_MESSAGE_MAP()
};
/*******************************************************/
BEGIN_MESSAGE_MAP(regdlg,CDialog)
ON_COMMAND(IDEXIT,exitbtn)
ON_COMMAND(IDC_RADIOHKLM,radiohklm)
ON_COMMAND(IDC_RADIOHKCU,radiohkcu)
ON_COMMAND(IDC_RADIOSTR,radiovaluestr)
ON_COMMAND(IDC_RADIOBIN,radiovaluebinary)
ON_COMMAND(IDC_RADIODW,radiovaluedword)
ON_COMMAND(IDC_RADIOMULTISTR,radiovaluemultistr)
ON_COMMAND(IDC_RADIOEXPANDSTR,radiovalueexpandstr)
ON_COMMAND(IDADDKEY,addregkey)
ON_COMMAND(IDDELKEY,delregkey)
ON_COMMAND(IDADDVALUE,setregval)
ON_COMMAND(IDDELVALUE,delregval)
ON_COMMAND(IDB_ABOUT,about)
ON_COMMAND(IDB_CLEAR,clear)
END_MESSAGE_MAP()

/***********************************************************/
class myapp : public CWinApp
{
public:
	int InitInstance()
	{   CString bindesh="This program is created by Bindesh Kumar Singh. It's a signature string";
		CString timestamp="26 August 2006" ;
		hdll = LoadLibrary("Myfunctions.dll");
		regdlg rd(IDD_REGDLG);
		rd.DoModal();
		FreeLibrary(hdll);
		return 1;
	}
};myapp ma;


void WhatError()
{ /* Code help from MSDN */
	LPVOID lpvbuf;
	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | /* LocalAlloc used and saves pointer in 5 argument.*/
    FORMAT_MESSAGE_FROM_SYSTEM,NULL,GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
    (LPTSTR)&lpvbuf,0,NULL);
	MessageBox(NULL,(LPCTSTR)lpvbuf,TEXT("INFORMATION"), MB_OK | MB_ICONINFORMATION );
	LocalFree(lpvbuf);
}